
--DROP TABLE USERS CASCADE CONSTRAINTS;
--DROP TABLE RECORDS CASCADE CONSTRAINTS;
--DROP SEQUENCE USER_ID_SEQ;
--DROP TRIGGER USRE_ID_TRIG;
--DROP SEQUENCE RECORD_ID_SEQ;
--DROP TRIGGER RECORD_ID_TRIG;


CREATE TABLE USERS(
	U_ID NUMBER(3) PRIMARY KEY,
	NAME VARCHAR2(25) NOT NULL,
	EMAIL VARCHAR2(40) NOT NULL,
	PASSWORD VARCHAR2(25) NOT NULL,
	STATUS VARCHAR2(5) CHECK (STATUS ='EMP' OR STATUS = 'MGMT')
	);


CREATE TABLE RECORDS(
	R_ID NUMBER(3) PRIMARY KEY,
	U_ID NUMBER(3) REFERENCES USERS,
	AMOUNT NUMBER(10,2) NOT NULL,
	REASON VARCHAR(40) NOT NULL,
	STATUS VARCHAR2(1) CHECK (STATUS ='Y' OR STATUS = 'N' OR STATUS='W')
);

CREATE SEQUENCE USER_ID_SEQ
MINVALUE 1
START WITH 1
INCREMENT BY 1
CACHE 5;

CREATE OR REPLACE TRIGGER USER_ID_TRIG
BEFORE INSERT ON USERS 
FOR EACH ROW
BEGIN 
	SELECT USER_ID_SEQ.NEXTVAL INTO :NEW.U_ID FROM DUAL;
END;

CREATE SEQUENCE RECORD_ID_SEQ
MINVALUE 1
START WITH 1
INCREMENT BY 1
CACHE 5;


CREATE OR REPLACE TRIGGER RECORD_ID_TRIG
BEFORE INSERT ON RECORDS
FOR EACH ROW
BEGIN 
	SELECT RECORD_ID_SEQ.NEXTVAL INTO :NEW.R_ID FROM DUAL;
END;

--Inserting user data
INSERT INTO USERS(NAME,EMAIL,PASSWORD,STATUS) VALUES ('Trevor Roy','troy@fakeemail','1234','MGMT');

INSERT INTO USERS(NAME,EMAIL,PASSWORD,STATUS) VALUES ('Thomas Anderson','neo@matrix','Chosen0ne','MGMT');

INSERT INTO USERS(NAME,EMAIL,PASSWORD,STATUS) VALUES ('John Lennon','imagine@beatles.com','LetItBe','EMP');

INSERT INTO USERS(NAME,EMAIL,PASSWORD,STATUS) VALUES ('Luke Skywaler','jedi@likemyfather','R2D2','EMP');

--Inserting record data
INSERT INTO RECORDS(U_ID,AMOUNT,REASON,STATUS) VALUES(3,500.50,'New guitar','W');

INSERT INTO RECORDS(U_ID,AMOUNT,REASON,STATUS) VALUES(3,6079.99,'New bed','N');

INSERT INTO RECORDS(U_ID,AMOUNT,REASON,STATUS) VALUES(4,1000000.00,'New hand','W');

INSERT INTO RECORDS(U_ID,AMOUNT,REASON,STATUS) VALUES(3,42,'New friends','Y');




















